// =================================================================================================
//
//   File....... jm_Animation.h
//               -- adapted by David Betz from dc22_badge_master.spin
//               -- for internal use only!
//               -- no changes unless approved/reviewed by JonnyMac/Ryan
// 
//   Authors.... Jon "JonnyMac" McPhalen and Ryan "1o57" Clarke
//               Converted to C++ by David Betz
//               MIT License
//               -- see below for terms of use
//
//   E-mail..... jon@jonmcphalen.com
//               1o57@10000100001.org
//               dbetz@xlisper.com 
//
// =================================================================================================

#ifndef __JM_ANIMATION_H__
#define __JM_ANIMATION_H__

class jm_Animation {
public:
  jm_Animation(int firstLed, int count);
  ~jm_Animation() { stop(); }
  int start(uint8_t *p_table, int cycles);
  void stop();
  bool running() { return cogId >= 0; }
private:
  static const int posx = 0x7fffffff;
  static void run_main(void *par);
  void run();
  void set_leds(int pattern);
  int shift;
  uint32_t mask;
  uint8_t *p_table;
  int cycles;
  long stack[EXTRA_STACK_LONGS + 32];
  int cogId;
};

#endif

/*

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/