// =================================================================================================
//
//   File....... jm_eztimer.spin
//   Purpose.... Asyncrhonous (accumulator) timer
//               -- methods must be called every ~53.687s (80MHz) or sooner to prevent rollover
//   Author..... Jon "JonnyMac" McPhalen
//               Copyright (c) 2014 Jon McPhalen
//               -- see below for terms of use
//   E-mail..... jon@jonmcphalen.com
//   Started.... 
//   Updated.... 23 MAY 2014
//
// =================================================================================================

#ifndef __JM_EZTIMER_H__
#define __JM_EZTIMER_H__

class jm_EzTimer {
public:
    jm_EzTimer() {}
    ~jm_EzTimer() {}
    void start();
    void startx(int spoint);
    int millis();
    int seconds();
    void adjust(int msoffset);
    int mark();
    int get_sync();
private:
    long sync;                                                  // sync point (snapshot of cnt)
    long tix;                                                   // ticks accumulator
    long tms;                                                   // ticks per millisecond
    long ms;                                                    // milliseconds accumulator
};  

#endif
