// =================================================================================================
//
//   File....... jm_prng.h
//   Purpose.... Better psuedo random number generator
//   Author..... Michael Rychlik  
//               -- reformatted by Jon "JonnyMac" McPhalen
//               -- see below for terms of use
//   E-mail.....  
//   Started.... 31 NOV 2011
//   Updated.... 05 MAY 2012
//
// =================================================================================================

#ifndef __JM_PRNG_H__
#define __JM_PRNG_H__

class jm_Prng {
public:
    jm_Prng();
    jm_Prng(int xx, int yy, int zz, int ww, int cc);
    ~jm_Prng() {}
    void seed(int xx, int yy, int zz, int ww, int cc);
    int random();
private:
    int x;
    int y;
    int z;
    int w;
    int c;
};

#endif

/*

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*/
